SystemOrganization addCategory: #GaruthaContactBook!

TestCase subclass: #ContactBookTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GaruthaContactBook'!

!ContactBookTest methodsFor: 'tests' stamp: 'GabrielGermain 10/17/2018 23:53'!
testRemoveContact
	| contact book |
	contact := Contact newNamed: 'Gab Ger' email: 'gg@gmail.com'.
	book := ContactBook new.
	book addContact: contact.
	self assert: (book contacts includes: contact ).
	book removeContact: contact.
	self assert: (book contacts isEmpty)! !

!ContactBookTest methodsFor: 'tests' stamp: 'GabrielGermain 10/17/2018 23:54'!
testRemoveUnkownContact
	| contact book |
	contact := Contact newNamed: 'Gab Ger' email: 'gg@gmail.com'.
	book := ContactBook new.
	book removeContact: contact.
	self assert: (book contacts isEmpty)! !

TestCase subclass: #ContactTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GaruthaContactBook'!

!ContactTest methodsFor: 'tests' stamp: 'GabrielGermain 10/17/2018 23:01'!
testCreation
	| contact |
	contact := Contact newNamed: 'Marcus Denker' email: 'marcus.denker@inria.fr'.
	self assert: contact fullname equals: 'Marcus Denker'.
	self assert: contact email equals: 'marcus.denker@inria.fr'! !

!ContactTest methodsFor: 'tests' stamp: 'GabrielGermain 10/17/2018 23:58'!
testPrintOn
	| contact |
	contact := Contact newNamed: 'Marcus Denker' email: 'marcus.denker@inria.fr'.
	self assert: contact asString equals: 'Marcus Denker <marcus.denker@inria.fr>'.! !

Object subclass: #Contact
	instanceVariableNames: 'fullname email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GaruthaContactBook'!

!Contact commentStamp: 'GabrielGermain 10/17/2018 23:02' prior: 0!
I represent a person with a name and an email address. I'm usually
part of a contact book.!

!Contact class methodsFor: 'instance creation' stamp: 'GabrielGermain 10/17/2018 23:01'!
newNamed: aNameString email: anEmailString
	^ self new
		fullname: aNameString;
		email: anEmailString;
		yourself! !

!Contact methodsFor: 'accessing' stamp: 'GabrielGermain 10/17/2018 23:00'!
email
	^ email! !

!Contact methodsFor: 'accessing' stamp: 'GabrielGermain 10/17/2018 23:00'!
email: aString 
	email := aString! !

!Contact methodsFor: 'accessing' stamp: 'GabrielGermain 10/17/2018 23:00'!
fullname
	^ fullname! !

!Contact methodsFor: 'accessing' stamp: 'GabrielGermain 10/17/2018 22:59'!
fullname: aString 
	fullname := aString! !

!Contact methodsFor: 'printing' stamp: 'GabrielGermain 10/17/2018 23:28'!
printOn: sStream
	sStream
		<< self fullname;
		<< ' <';
		<< self email;
		<< '>'! !

Object subclass: #ContactBook
	instanceVariableNames: 'contacts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GaruthaContactBook'!

!ContactBook commentStamp: 'GabrielGermain 10/17/2018 23:33' prior: 0!
I'm a ContactBook.!

!ContactBook methodsFor: 'accessing' stamp: 'GabrielGermain 10/17/2018 23:35'!
addContact: aContact
	self contacts add: aContact! !

!ContactBook methodsFor: 'accessing' stamp: 'GabrielGermain 10/17/2018 23:34'!
contacts
	^ contacts ifNil: [ contacts := OrderedCollection new ]! !

!ContactBook methodsFor: 'accessing' stamp: 'GabrielGermain 10/17/2018 23:56'!
removeContact: aContact
	self contacts remove: aContact ifAbsent: [  ]! !
